---
title: HTMLTextAreaElement
slug: Web/API/HTMLTextAreaElement
tags:
  - API
  - HTML DOM
  - HTMLTextAreaElement
  - Interface
  - Reference
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>HTMLTextAreaElement</code></strong> interface provides special properties and methods for manipulating the layout and presentation of {{HTMLElement("textarea")}} elements.</p>

<p>{{InheritanceDiagram(600,120)}}</p>

<h2 id="Properties">Properties</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <td><code>accessKey</code></td>
   <td><code><em>string</em>:</code> Returns / Sets the element's {{htmlattrxref("accesskey", "textarea")}} attribute.</td>
  </tr>
  <tr>
   <td><code>autocapitalize</code> {{experimental_inline}}</td>
   <td><code><em>string</em>:</code> Returns / Sets the element's capitalization behavior for user input. Valid values are: <code>none</code>, <code>off</code>, <code>characters</code>, <code>words</code>, <code>sentences</code>.</td>
  </tr>
  <tr>
   <td><code>autocomplete</code> {{experimental_inline}}</td>
   <td></td>
  </tr>
  <tr>
   <td><code>autofocus</code></td>
   <td><code><em>boolean</em>:</code> Returns / Sets the element's {{htmlattrxref("autofocus", "textarea")}} attribute, indicating that the control should have input focus when the page loads</td>
  </tr>
  <tr>
   <td><code>cols</code></td>
   <td><code><em>unsigned long</em>:</code> Returns / Sets the element's {{htmlattrxref("cols", "textarea")}} attribute, indicating the visible width of the text area.</td>
  </tr>
  <tr>
   <td><code>defaultValue</code></td>
   <td><code><em>string</em>:</code> Returns / Sets the control's default value, which behaves like the {{domxref("Node.textContent")}} property.</td>
  </tr>
  <tr>
   <td><code>disabled</code></td>
   <td><code><em>boolean</em>:</code> Returns / Sets the element's {{htmlattrxref("disabled", "textarea")}} attribute, indicating that the control is not available for interaction.</td>
  </tr>
  <tr>
   <td><code>form</code> {{readonlyInline}}</td>
   <td><code><em>object</em>:</code> Returns a reference to the parent form element. If this element is not contained in a form element, it can be the {{htmlattrxref("id", "form")}} attribute of any {{HTMLElement("form")}} element in the same document or the value <code>null</code>.</td>
  </tr>
  <tr>
   <td><code>inputMode</code> {{experimental_inline}}</td>
   <td></td>
  </tr>
  <tr>
   <td><code>maxLength</code></td>
   <td><code><em>long</em>:</code> Returns / Sets the element's {{htmlattrxref("maxlength", "textarea")}} attribute, indicating the maximum number of characters the user can enter. This constraint is evaluated only when the value changes.</td>
  </tr>
  <tr>
   <td><code>minLength</code></td>
   <td><code><em>long</em>:</code> Returns / Sets the element's {{htmlattrxref("minlength", "textarea")}} attribute, indicating the minimum number of characters the user can enter. This constraint is evaluated only when the value changes.</td>
  </tr>
  <tr>
   <td><code>name</code></td>
   <td><code><em>string</em>:</code> Returns / Sets the element's {{htmlattrxref("name", "textarea")}} attribute, containing the name of the control.</td>
  </tr>
  <tr>
   <td><code>placeholder</code></td>
   <td><code><em>string</em>:</code> Returns / Sets the element's {{htmlattrxref("placeholder", "textarea")}} attribute, containing a hint to the user about what to enter in the control.</td>
  </tr>
  <tr>
   <td><code>readOnly</code></td>
   <td><code><em>boolean</em>:</code> Returns / Sets the element's {{htmlattrxref("readonly", "textarea")}} attribute, indicating that the user cannot modify the value of the control.</td>
  </tr>
  <tr>
   <td><code>required</code></td>
   <td><code><em>boolean</em>:</code> Returns / Sets the element's {{htmlattrxref("required", "textarea")}} attribute, indicating that the user must specify a value before submitting the form.</td>
  </tr>
  <tr>
   <td><code>rows</code></td>
   <td><code><em>unsigned long</em>:</code> Returns / Sets the element's {{htmlattrxref("rows", "textarea")}} attribute, indicating the number of visible text lines for the control.</td>
  </tr>
  <tr>
   <td><code>selectionDirection</code></td>
   <td><code><em>string</em>:</code> Returns / Sets the direction in which selection occurred. This is "<code>forward</code>" if selection was performed in the start-to-end direction of the current locale, or "<code>backward</code>" for the opposite direction. This can also be "<code>none</code>" if the direction is unknown.</td>
  </tr>
  <tr>
   <td><code>selectionEnd</code></td>
   <td><code><em>unsigned long</em>:</code> Returns / Sets the index of the end of selected text. If no text is selected, contains the index of the character that follows the input cursor. On being set, the control behaves as if <code>setSelectionRange()</code> had been called with this as the second argument, and <code>selectionStart</code> as the first argument.</td>
  </tr>
  <tr>
   <td><code>selectionStart</code></td>
   <td><code><em>unsigned long</em>:</code> Returns / Sets the index of the beginning of selected text. If no text is selected, contains the index of the character that follows the input cursor. On being set, the control behaves as if <code>setSelectionRange()</code> had been called with this as the first argument, and <code>selectionEnd</code> as the second argument.</td>
  </tr>
  <tr>
   <td><code>tabIndex</code></td>
   <td><code><em>long</em>:</code> Returns / Sets the position of the element in the tabbing navigation order for the current document.</td>
  </tr>
  <tr>
   <td><code>textLength</code> {{readonlyInline}}</td>
   <td><code><em>long</em>:</code> Returns the codepoint length of the control's <code>value</code>. Same as reading <code>value.length</code></td>
  </tr>
  <tr>
   <td><code>type</code> {{readonlyInline}}</td>
   <td><code><em>string</em>:</code> Returns the string <code>textarea</code>.</td>
  </tr>
  <tr>
   <td><code>validationMessage</code> {{readonlyInline}}</td>
   <td><code><em>string</em>:</code> Returns a localized message that describes the validation constraints that the control does not satisfy (if any). This is the empty string if the control is not a candidate for constraint validation (<code>willValidate</code> is <code>false</code>), or it satisfies its constraints.</td>
  </tr>
  <tr>
   <td><code>validity</code> {{readonlyInline}}</td>
   <td><code><em>{{domxref("ValidityState")}} object</em>:</code> Returns the validity states that this element is in.</td>
  </tr>
  <tr>
   <td><code>value</code></td>
   <td><code><em>string</em>:</code> Returns / Sets the raw value contained in the control.</td>
  </tr>
  <tr>
   <td><code>willValidate</code> {{readonlyInline}}</td>
   <td>
    <p><code><em>boolean</em>:</code> Returns whether the element is a candidate for constraint validation. <code>false</code> if any conditions bar it from constraint validation, including its <code>readOnly</code> or <code>disabled</code> property is <code>true</code>.</p>
   </td>
  </tr>
  <tr>
   <td><code>wrap</code> {{gecko_minversion_inline("2.0")}}</td>
   <td><code><em>string</em>:</code> Returns / Sets the {{htmlattrxref("wrap", "textarea")}} HTML attribute, indicating how the control wraps text.</td>
  </tr>
  <tr>
   <td>{{domxref("HTMLTextAreaElement.labels")}}{{ReadOnlyInline}}</td>
   <td>{{domxref("NodeList")}}: Returns a list of label elements associated with this element.</td>
  </tr>
 </tbody>
</table>

<p>The two properties <code>tabIndex</code> and <code>accessKey</code> are inherited from {{domxref("HTMLElement")}} from HTML5 on, but were defined on <code>HTMLTextAreaElement</code> in DOM Level 2 HTML and earlier specifications.</p>

<h2 id="Methods">Methods</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <td>{{domxref("HTMLElement/blur", "blur()")}}</td>
   <td>Removes focus from the control; keystrokes will subsequently go nowhere.</td>
  </tr>
  <tr>
   <td>{{domxref("HTMLElement/focus", "focus()")}}</td>
   <td>Gives focus to the control; keystrokes will subsequently go to this element.</td>
  </tr>
  <tr>
   <td>{{domxref("HTMLInputElement/select", "select()")}}</td>
   <td>Selects the contents of the control.</td>
  </tr>
  <tr>
   <td>{{domxref("HTMLInputElement/setRangeText", "setRangeText()")}}</td>
   <td>Replaces a range of text in the element with new text.</td>
  </tr>
  <tr>
   <td>{{domxref("HTMLInputElement/setSelectionRange", "setSelectionRange()")}}</td>
   <td>Selects a range of text in the element (but does not focus it).</td>
  </tr>
  <tr>
   <td><code>checkValidity()</code></td>
   <td>Returns <code>false</code> if the element is a candidate for constraint validation, and it does not satisfy its constraints. In this case, it also fires a cancelable <code>invalid</code> event at the control. It returns <code>true</code> if the control is not a candidate for constraint validation, or if it satisfies its constraints.</td>
  </tr>
  <tr>
   <td><code>reportValidity()</code></td>
   <td>
    <p>This method reports the problems with the constraints on the element, if any, to the user. If there are problems, it fires a cancelable <code>invalid</code> event at the element, and returns <code>false</code>; if there are no problems, it returns <code>true</code>.</p>
   </td>
  </tr>
  <tr>
   <td><code>setCustomValidity(DOMstring)</code></td>
   <td>Sets a custom validity message for the element. If this message is not the empty string, then the element is suffering from a custom validity error, and does not validate.</td>
  </tr>
 </tbody>
</table>

<p>The two methods <code>blur()</code> and <code>focus()</code> are inherited from {{domxref("HTMLElement")}} from HTML5 on, but were defined on <code>HTMLTextAreaElement</code> in DOM Level 2 HTML and earlier specifications.</p>

<h2 id="Events">Events</h2>

<p>Listen to these events using {{domxref("EventTarget/addEventListener", "addEventListener()")}} or by assigning an event listener to the <code>on<em>eventname</em></code> property of this interface:</p>

<dl>
 <dt>{{domxref("HTMLElement/input_event", "input")}} event</dt>
 <dd>Fires when the <code>value</code> of an {{HTMLElement("input")}}, {{HTMLElement("select")}}, or {{HTMLElement("textarea")}} element has been changed.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Autogrowing_textarea_example">Autogrowing textarea example</h3>

<p>Make a textarea autogrow while typing:</p>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">function autoGrow (oField) {
  if (oField.scrollHeight &gt; oField.clientHeight) {
    oField.style.height = oField.scrollHeight + "px";
  }
}</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">textarea.noscrollbars {
  overflow: hidden;
  width: 300px;
  height: 100px;
}</pre>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;fieldset&gt;
    &lt;legend&gt;Your comments&lt;/legend&gt;
    &lt;p&gt;&lt;textarea class="noscrollbars" onkeyup="autoGrow(this);"&gt;&lt;/textarea&gt;&lt;/p&gt;
    &lt;p&gt;&lt;input type="submit" value="Send" /&gt;&lt;/p&gt;
  &lt;/fieldset&gt;
&lt;/form&gt;
</pre>

<p>{{EmbedLiveSample('Autogrowing_textarea_example', 600, 300)}}</p>

<h3 id="Insert_HTML_tags_example">Insert HTML tags example</h3>

<p>Insert some HTML tags or <em>smiles</em> or any custom text in a textarea.</p>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js notranslate">function insertMetachars(sStartTag, sEndTag) {
  var bDouble = arguments.length &gt; 1, oMsgInput = document.myForm.myTxtArea, nSelStart = oMsgInput.selectionStart, nSelEnd = oMsgInput.selectionEnd, sOldText = oMsgInput.value;
  oMsgInput.value = sOldText.substring(0, nSelStart) + (bDouble ? sStartTag + sOldText.substring(nSelStart, nSelEnd) + sEndTag : sStartTag) + sOldText.substring(nSelEnd);
  oMsgInput.setSelectionRange(bDouble || nSelStart === nSelEnd ? nSelStart + sStartTag.length : nSelStart, (bDouble ? nSelEnd : nSelStart) + sStartTag.length);
  oMsgInput.focus();
}</pre>

<h4 id="CSS_2">CSS</h4>

<p>CSS to decorate the internal span to behave like a link:</p>

<pre class="brush: css notranslate">.intLink {
  cursor: pointer;
  text-decoration: underline;
  color: #0000ff;
}</pre>

<p>HTML:</p>

<pre class="brush: html notranslate">&lt;form name="myForm"&gt;
&lt;p&gt;[&amp;nbsp;&lt;span class="intLink" onclick="insertMetachars('&amp;lt;strong&amp;gt;','&amp;lt;\/strong&amp;gt;');"&gt;&lt;strong&gt;Bold&lt;/strong&gt;&lt;/span&gt; | &lt;span class="intLink" onclick="insertMetachars('&amp;lt;em&amp;gt;','&amp;lt;\/em&amp;gt;');"&gt;&lt;em&gt;Italic&lt;/em&gt;&lt;/span&gt; | &lt;span class="intLink" onclick="var newURL=prompt('Enter the full URL for the link');if(newURL){insertMetachars('&amp;lt;a href=\u0022'+newURL+'\u0022&amp;gt;','&amp;lt;\/a&amp;gt;');}else{document.myForm.myTxtArea.focus();}"&gt;URL&lt;/span&gt; | &lt;span class="intLink" onclick="insertMetachars('\n&amp;lt;code&amp;gt;\n','\n&amp;lt;\/code&amp;gt;\n');"&gt;code&lt;/span&gt; | &lt;span class="intLink" onclick="insertMetachars(' :-)');"&gt;smile&lt;/span&gt; | etc. etc.&amp;nbsp;]&lt;/p&gt;
&lt;p&gt;&lt;textarea name="myTxtArea" rows="10" cols="50"&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut facilisis, arcu vitae adipiscing placerat, nisl lectus accumsan nisi, vitae iaculis sem neque vel lectus. Praesent tristique commodo lorem quis fringilla. Sed ac tellus eros. Sed consectetur eleifend felis vitae luctus. Praesent sagittis, est eget bibendum tincidunt, ligula diam tincidunt augue, a fermentum odio velit eget mi. Phasellus mattis, elit id fringilla semper, orci magna cursus ligula, non venenatis lacus augue sit amet dui. Pellentesque lacinia odio id nisi pulvinar commodo tempus at odio. Ut consectetur eros porttitor nunc mollis ultrices. Aenean porttitor, purus sollicitudin viverra auctor, neque erat blandit sapien, sit amet tincidunt massa mi ac nibh. Proin nibh sem, bibendum ut placerat nec, cursus et lacus. Phasellus vel augue turpis. Nunc eu mauris eu leo blandit mollis interdum eget lorem. &lt;/textarea&gt;&lt;/p&gt;
&lt;/form&gt;
</pre>

<p>{{EmbedLiveSample('Insert_HTML_tags_example', 600, 300)}}</p>

<h3 id="Maximum_length_and_number_of_lines_example">Maximum length and number of lines example</h3>

<p>Create a textarea with a maximum number of characters per line and a maximum number of lines:</p>

<p>First, create a function that takes the text field and a key event as input and determines if any of the limits have been reached. If the limit has not been reached, it will return the key.</p>

<pre class="brush: js notranslate">function checkRows(oField, oKeyEvent) {
  var nKey = (oKeyEvent || /* old IE */ window.event || /* check is not supported! */ { keyCode: 38 }).keyCode,

    // put here the maximum number of characters per line:
    nCols = 30,
    // put here the maximum number of lines:
    nRows = 5,

    nSelS = oField.selectionStart, nSelE = oField.selectionEnd,
    sVal = oField.value, nLen = sVal.length,

    nBackward = nSelS &gt;= nCols ? nSelS - nCols : 0,
    nDeltaForw = sVal.substring(nBackward, nSelS).search(new RegExp("\\n(?!.{0," + String(nCols - 2) + "}\\n)")) + 1,
    nRowStart = nBackward + nDeltaForw,
    aReturns = (sVal.substring(0, nSelS) + sVal.substring(nSelE, sVal.length)).match(/\n/g),
    nRowEnd = nSelE + nRowStart + nCols - nSelS,
    sRow = sVal.substring(nRowStart, nSelS) + sVal.substring(nSelE, nRowEnd &gt; nLen ? nLen : nRowEnd),
    bKeepCols = nKey === 13 || nLen + 1 &lt; nCols || /\n/.test(sRow) || ((nRowStart === 0 || nDeltaForw &gt; 0 || nKey &gt; 0) &amp;&amp; (sRow.length &lt; nCols || (nKey &gt; 0 &amp;&amp; (nLen === nRowEnd || sVal.charAt(nRowEnd) === "\n"))));

  return (nKey !== 13 || (aReturns ? aReturns.length + 1 : 1) &lt; nRows) &amp;&amp; ((nKey &gt; 32 &amp;&amp; nKey &lt; 41) || bKeepCols);
}</pre>

<p>In the HTML we just need to hook our function to the `onkeypress` event and specify that our textarea does not accept pasting:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;p&gt;Textarea with fixed number of characters per line:&lt;br /&gt;
    &lt;textarea cols="50" rows="10" onkeypress="return checkRows(this, event);"
              onpaste="return false;"&gt;&lt;/textarea&gt;
  &lt;/p&gt;
&lt;/form&gt;
</pre>

<p>{{EmbedLiveSample('Maximum_length_and_number_of_lines_example', 600, 300)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#htmltextareaelement", "HTMLTextAreaElement")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "forms.html#the-textarea-element", "HTMLTextAreaElement")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>The attributes <code>tabindex</code> and <code>accesskey</code>, as well as the methods <code>blur()</code> and <code>focus()</code> are now defined on {{domxref("HTMLElement")}}.<br>
    The following attributes have been added: <code>autofocus</code>, <code>placeholder</code>, <code>dirName</code>, <code>wrap</code>, <code>maxLength</code>, <code>required</code>, <code>textLength</code>, <code>labels</code>, <code>selectionStart</code>, <code>selectionEnd</code>, <code>selectionDirection</code>, <code>validity</code>, <code>validationMessage</code>, and <code>willValidate</code>.<br>
    The following methods have been added: <code>checkValidity()</code>, <code>setCustomValidity()</code>, and <code>setSelectionRange()</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 HTML', 'html.html#ID-ID-24874179', 'HTMLTextAreaElement')}}</td>
   <td>{{Spec2('DOM2 HTML')}}</td>
   <td>The property <code>defaultValue</code> doesn't contain the initial value of the <code>value</code> attribute, but the initial value of the content of the {{HTMLElement("textarea")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM1', 'level-one-html.html#ID-24874179', 'HTMLTextAreaElement')}}</td>
   <td>{{Spec2('DOM1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLTextAreaElement")}}</p>
